229f5f7ff1491ad5d98d9a35a6fe87fd77007296
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Keep the original TERM for say_color
  19ORIGINAL_TERM=$TERM
  20
  21# Test the binaries we have just built.  The tests are kept in
  22# t/ subdirectory and are run in 'trash directory' subdirectory.
  23if test -z "$TEST_DIRECTORY"
  24then
  25        # We allow tests to override this, in case they want to run tests
  26        # outside of t/, e.g. for running tests on the test library
  27        # itself.
  28        TEST_DIRECTORY=$(pwd)
  29fi
  30if test -z "$TEST_OUTPUT_DIRECTORY"
  31then
  32        # Similarly, override this to store the test-results subdir
  33        # elsewhere
  34        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  35fi
  36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  37
  38################################################################
  39# It appears that people try to run tests without building...
  40"$GIT_BUILD_DIR/git" >/dev/null
  41if test $? != 1
  42then
  43        echo >&2 'error: you do not seem to have built git yet.'
  44        exit 1
  45fi
  46
  47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  48export PERL_PATH SHELL_PATH
  49
  50# if --tee was passed, write the output not only to the terminal, but
  51# additionally to the file test-results/$BASENAME.out, too.
  52case "$GIT_TEST_TEE_STARTED, $* " in
  53done,*)
  54        # do not redirect again
  55        ;;
  56*' --tee '*|*' --va'*)
  57        mkdir -p test-results
  58        BASE=test-results/$(basename "$0" .sh)
  59        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  60         echo $? > $BASE.exit) | tee $BASE.out
  61        test "$(cat $BASE.exit)" = 0
  62        exit
  63        ;;
  64esac
  65
  66# For repeatability, reset the environment to known value.
  67LANG=C
  68LC_ALL=C
  69PAGER=cat
  70TZ=UTC
  71TERM=dumb
  72export LANG LC_ALL PAGER TERM TZ
  73EDITOR=:
  74# A call to "unset" with no arguments causes at least Solaris 10
  75# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  76# deriving from the command substitution clustered with the other
  77# ones.
  78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  79        my @env = keys %ENV;
  80        my $ok = join("|", qw(
  81                TRACE
  82                DEBUG
  83                USE_LOOKUP
  84                TEST
  85                .*_TEST
  86                PROVE
  87                VALGRIND
  88                UNZIP
  89                PERF_
  90        ));
  91        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  92        print join("\n", @vars);
  93')
  94unset XDG_CONFIG_HOME
  95GIT_AUTHOR_EMAIL=author@example.com
  96GIT_AUTHOR_NAME='A U Thor'
  97GIT_COMMITTER_EMAIL=committer@example.com
  98GIT_COMMITTER_NAME='C O Mitter'
  99GIT_MERGE_VERBOSITY=5
 100GIT_MERGE_AUTOEDIT=no
 101export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 102export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 103export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 104export EDITOR
 105
 106# Add libc MALLOC and MALLOC_PERTURB test
 107# only if we are not executing the test with valgrind
 108if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 109   test -n "$TEST_NO_MALLOC_CHECK"
 110then
 111        setup_malloc_check () {
 112                : nothing
 113        }
 114        teardown_malloc_check () {
 115                : nothing
 116        }
 117else
 118        setup_malloc_check () {
 119                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 120                export MALLOC_CHECK_ MALLOC_PERTURB_
 121        }
 122        teardown_malloc_check () {
 123                unset MALLOC_CHECK_ MALLOC_PERTURB_
 124        }
 125fi
 126
 127# Protect ourselves from common misconfiguration to export
 128# CDPATH into the environment
 129unset CDPATH
 130
 131unset GREP_OPTIONS
 132unset UNZIP
 133
 134case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1351|2|true)
 136        echo "* warning: Some tests will not work if GIT_TRACE" \
 137                "is set as to trace on STDERR ! *"
 138        echo "* warning: Please set GIT_TRACE to something" \
 139                "other than 1, 2 or true ! *"
 140        ;;
 141esac
 142
 143# Convenience
 144#
 145# A regexp to match 5 and 40 hexdigits
 146_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 147_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 148
 149# Zero SHA-1
 150_z40=0000000000000000000000000000000000000000
 151
 152# Line feed
 153LF='
 154'
 155
 156export _x05 _x40 _z40 LF
 157
 158# Each test should start with something like this, after copyright notices:
 159#
 160# test_description='Description of this test...
 161# This test checks if command xyzzy does the right thing...
 162# '
 163# . ./test-lib.sh
 164[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 165                TERM=$ORIGINAL_TERM &&
 166                export TERM &&
 167                [ -t 1 ] &&
 168                tput bold >/dev/null 2>&1 &&
 169                tput setaf 1 >/dev/null 2>&1 &&
 170                tput sgr0 >/dev/null 2>&1
 171        ) &&
 172        color=t
 173
 174while test "$#" -ne 0
 175do
 176        case "$1" in
 177        -d|--d|--de|--deb|--debu|--debug)
 178                debug=t; shift ;;
 179        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 180                immediate=t; shift ;;
 181        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 182                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 183        -h|--h|--he|--hel|--help)
 184                help=t; shift ;;
 185        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 186                verbose=t; shift ;;
 187        -q|--q|--qu|--qui|--quie|--quiet)
 188                # Ignore --quiet under a TAP::Harness. Saying how many tests
 189                # passed without the ok/not ok details is always an error.
 190                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 191        --with-dashes)
 192                with_dashes=t; shift ;;
 193        --no-color)
 194                color=; shift ;;
 195        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 196                valgrind=memcheck
 197                shift ;;
 198        --valgrind=*)
 199                valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
 200                shift ;;
 201        --tee)
 202                shift ;; # was handled already
 203        --root=*)
 204                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 205                shift ;;
 206        *)
 207                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 208        esac
 209done
 210
 211test -n "$valgrind" && verbose=t
 212
 213if test -n "$color"
 214then
 215        say_color () {
 216                (
 217                TERM=$ORIGINAL_TERM
 218                export TERM
 219                case "$1" in
 220                error)
 221                        tput bold; tput setaf 1;; # bold red
 222                skip)
 223                        tput setaf 4;; # blue
 224                warn)
 225                        tput setaf 3;; # brown/yellow
 226                pass)
 227                        tput setaf 2;; # green
 228                info)
 229                        tput setaf 6;; # cyan
 230                *)
 231                        test -n "$quiet" && return;;
 232                esac
 233                shift
 234                printf "%s" "$*"
 235                tput sgr0
 236                echo
 237                )
 238        }
 239else
 240        say_color() {
 241                test -z "$1" && test -n "$quiet" && return
 242                shift
 243                printf "%s\n" "$*"
 244        }
 245fi
 246
 247error () {
 248        say_color error "error: $*"
 249        GIT_EXIT_OK=t
 250        exit 1
 251}
 252
 253say () {
 254        say_color info "$*"
 255}
 256
 257test "${test_description}" != "" ||
 258error "Test script did not set test_description."
 259
 260if test "$help" = "t"
 261then
 262        echo "$test_description"
 263        exit 0
 264fi
 265
 266exec 5>&1
 267exec 6<&0
 268if test "$verbose" = "t"
 269then
 270        exec 4>&2 3>&1
 271else
 272        exec 4>/dev/null 3>/dev/null
 273fi
 274
 275test_failure=0
 276test_count=0
 277test_fixed=0
 278test_broken=0
 279test_success=0
 280
 281test_external_has_tap=0
 282
 283die () {
 284        code=$?
 285        if test -n "$GIT_EXIT_OK"
 286        then
 287                exit $code
 288        else
 289                echo >&5 "FATAL: Unexpected exit with code $code"
 290                exit 1
 291        fi
 292}
 293
 294GIT_EXIT_OK=
 295trap 'die' EXIT
 296
 297# The user-facing functions are loaded from a separate file so that
 298# test_perf subshells can have them too
 299. "$TEST_DIRECTORY/test-lib-functions.sh"
 300
 301# You are not expected to call test_ok_ and test_failure_ directly, use
 302# the text_expect_* functions instead.
 303
 304test_ok_ () {
 305        test_success=$(($test_success + 1))
 306        say_color "" "ok $test_count - $@"
 307}
 308
 309test_failure_ () {
 310        test_failure=$(($test_failure + 1))
 311        say_color error "not ok $test_count - $1"
 312        shift
 313        echo "$@" | sed -e 's/^/#       /'
 314        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 315}
 316
 317test_known_broken_ok_ () {
 318        test_fixed=$(($test_fixed+1))
 319        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 320}
 321
 322test_known_broken_failure_ () {
 323        test_broken=$(($test_broken+1))
 324        say_color warn "not ok $test_count - $@ # TODO known breakage"
 325}
 326
 327test_debug () {
 328        test "$debug" = "" || eval "$1"
 329}
 330
 331test_eval_ () {
 332        # This is a separate function because some tests use
 333        # "return" to end a test_expect_success block early.
 334        eval </dev/null >&3 2>&4 "$*"
 335}
 336
 337test_run_ () {
 338        test_cleanup=:
 339        expecting_failure=$2
 340        setup_malloc_check
 341        test_eval_ "$1"
 342        eval_ret=$?
 343        teardown_malloc_check
 344
 345        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 346        then
 347                setup_malloc_check
 348                test_eval_ "$test_cleanup"
 349                teardown_malloc_check
 350        fi
 351        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 352        then
 353                echo ""
 354        fi
 355        return "$eval_ret"
 356}
 357
 358test_skip () {
 359        test_count=$(($test_count+1))
 360        to_skip=
 361        for skp in $GIT_SKIP_TESTS
 362        do
 363                case $this_test.$test_count in
 364                $skp)
 365                        to_skip=t
 366                        break
 367                esac
 368        done
 369        if test -z "$to_skip" && test -n "$test_prereq" &&
 370           ! test_have_prereq "$test_prereq"
 371        then
 372                to_skip=t
 373        fi
 374        case "$to_skip" in
 375        t)
 376                of_prereq=
 377                if test "$missing_prereq" != "$test_prereq"
 378                then
 379                        of_prereq=" of $test_prereq"
 380                fi
 381
 382                say_color skip >&3 "skipping test: $@"
 383                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 384                : true
 385                ;;
 386        *)
 387                false
 388                ;;
 389        esac
 390}
 391
 392# stub; perf-lib overrides it
 393test_at_end_hook_ () {
 394        :
 395}
 396
 397test_done () {
 398        GIT_EXIT_OK=t
 399
 400        if test -z "$HARNESS_ACTIVE"
 401        then
 402                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 403                mkdir -p "$test_results_dir"
 404                base=${0##*/}
 405                test_results_path="$test_results_dir/${base%.sh}-$$.counts"
 406
 407                cat >>"$test_results_path" <<-EOF
 408                total $test_count
 409                success $test_success
 410                fixed $test_fixed
 411                broken $test_broken
 412                failed $test_failure
 413
 414                EOF
 415        fi
 416
 417        if test "$test_fixed" != 0
 418        then
 419                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 420        fi
 421        if test "$test_broken" != 0
 422        then
 423                say_color warn "# still have $test_broken known breakage(s)"
 424        fi
 425        if test "$test_broken" != 0 || test "$test_fixed" != 0
 426        then
 427                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 428                msg="remaining $test_remaining test(s)"
 429        else
 430                test_remaining=$test_count
 431                msg="$test_count test(s)"
 432        fi
 433        case "$test_failure" in
 434        0)
 435                # Maybe print SKIP message
 436                if test -n "$skip_all" && test $test_count -gt 0
 437                then
 438                        error "Can't use skip_all after running some tests"
 439                fi
 440                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 441
 442                if test $test_external_has_tap -eq 0
 443                then
 444                        if test $test_remaining -gt 0
 445                        then
 446                                say_color pass "# passed all $msg"
 447                        fi
 448                        say "1..$test_count$skip_all"
 449                fi
 450
 451                test -d "$remove_trash" &&
 452                cd "$(dirname "$remove_trash")" &&
 453                rm -rf "$(basename "$remove_trash")"
 454
 455                test_at_end_hook_
 456
 457                exit 0 ;;
 458
 459        *)
 460                if test $test_external_has_tap -eq 0
 461                then
 462                        say_color error "# failed $test_failure among $msg"
 463                        say "1..$test_count"
 464                fi
 465
 466                exit 1 ;;
 467
 468        esac
 469}
 470
 471if test -n "$valgrind"
 472then
 473        make_symlink () {
 474                test -h "$2" &&
 475                test "$1" = "$(readlink "$2")" || {
 476                        # be super paranoid
 477                        if mkdir "$2".lock
 478                        then
 479                                rm -f "$2" &&
 480                                ln -s "$1" "$2" &&
 481                                rm -r "$2".lock
 482                        else
 483                                while test -d "$2".lock
 484                                do
 485                                        say "Waiting for lock on $2."
 486                                        sleep 1
 487                                done
 488                        fi
 489                }
 490        }
 491
 492        make_valgrind_symlink () {
 493                # handle only executables, unless they are shell libraries that
 494                # need to be in the exec-path.  We will just use "#!" as a
 495                # guess for a shell-script, since we have no idea what the user
 496                # may have configured as the shell path.
 497                test -x "$1" ||
 498                test "#!" = "$(head -c 2 <"$1")" ||
 499                return;
 500
 501                base=$(basename "$1")
 502                symlink_target=$GIT_BUILD_DIR/$base
 503                # do not override scripts
 504                if test -x "$symlink_target" &&
 505                    test ! -d "$symlink_target" &&
 506                    test "#!" != "$(head -c 2 < "$symlink_target")"
 507                then
 508                        symlink_target=../valgrind.sh
 509                fi
 510                case "$base" in
 511                *.sh|*.perl)
 512                        symlink_target=../unprocessed-script
 513                esac
 514                # create the link, or replace it if it is out of date
 515                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 516        }
 517
 518        # override all git executables in TEST_DIRECTORY/..
 519        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 520        mkdir -p "$GIT_VALGRIND"/bin
 521        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 522        do
 523                make_valgrind_symlink $file
 524        done
 525        # special-case the mergetools loadables
 526        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 527        OLDIFS=$IFS
 528        IFS=:
 529        for path in $PATH
 530        do
 531                ls "$path"/git-* 2> /dev/null |
 532                while read file
 533                do
 534                        make_valgrind_symlink "$file"
 535                done
 536        done
 537        IFS=$OLDIFS
 538        PATH=$GIT_VALGRIND/bin:$PATH
 539        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 540        export GIT_VALGRIND
 541        GIT_VALGRIND_MODE="$valgrind"
 542        export GIT_VALGRIND_MODE
 543elif test -n "$GIT_TEST_INSTALLED"
 544then
 545        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 546        error "Cannot run git from $GIT_TEST_INSTALLED."
 547        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 548        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 549else # normal case, use ../bin-wrappers only unless $with_dashes:
 550        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 551        if ! test -x "$git_bin_dir/git"
 552        then
 553                if test -z "$with_dashes"
 554                then
 555                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 556                fi
 557                with_dashes=t
 558        fi
 559        PATH="$git_bin_dir:$PATH"
 560        GIT_EXEC_PATH=$GIT_BUILD_DIR
 561        if test -n "$with_dashes"
 562        then
 563                PATH="$GIT_BUILD_DIR:$PATH"
 564        fi
 565fi
 566GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 567unset GIT_CONFIG
 568GIT_CONFIG_NOSYSTEM=1
 569GIT_ATTR_NOSYSTEM=1
 570export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 571
 572if test -z "$GIT_TEST_CMP"
 573then
 574        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 575        then
 576                GIT_TEST_CMP="$DIFF -c"
 577        else
 578                GIT_TEST_CMP="$DIFF -u"
 579        fi
 580fi
 581
 582GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 583export GITPERLLIB
 584test -d "$GIT_BUILD_DIR"/templates/blt || {
 585        error "You haven't built things yet, have you?"
 586}
 587
 588if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 589then
 590        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 591        export GITPYTHONLIB
 592        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 593                error "You haven't built git_remote_helpers yet, have you?"
 594        }
 595fi
 596
 597if ! test -x "$GIT_BUILD_DIR"/test-chmtime
 598then
 599        echo >&2 'You need to build test-chmtime:'
 600        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 601        exit 1
 602fi
 603
 604# Test repository
 605TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 606test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 607case "$TRASH_DIRECTORY" in
 608/*) ;; # absolute path is good
 609 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 610esac
 611test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 612rm -fr "$TRASH_DIRECTORY" || {
 613        GIT_EXIT_OK=t
 614        echo >&5 "FATAL: Cannot prepare test area"
 615        exit 1
 616}
 617
 618HOME="$TRASH_DIRECTORY"
 619export HOME
 620
 621if test -z "$TEST_NO_CREATE_REPO"
 622then
 623        test_create_repo "$TRASH_DIRECTORY"
 624else
 625        mkdir -p "$TRASH_DIRECTORY"
 626fi
 627# Use -P to resolve symlinks in our working directory so that the cwd
 628# in subprocesses like git equals our $PWD (for pathname comparisons).
 629cd -P "$TRASH_DIRECTORY" || exit 1
 630
 631this_test=${0##*/}
 632this_test=${this_test%%-*}
 633for skp in $GIT_SKIP_TESTS
 634do
 635        case "$this_test" in
 636        $skp)
 637                say_color info >&3 "skipping test $this_test altogether"
 638                skip_all="skip all tests in $this_test"
 639                test_done
 640        esac
 641done
 642
 643# Provide an implementation of the 'yes' utility
 644yes () {
 645        if test $# = 0
 646        then
 647                y=y
 648        else
 649                y="$*"
 650        fi
 651
 652        while echo "$y"
 653        do
 654                :
 655        done
 656}
 657
 658# Fix some commands on Windows
 659case $(uname -s) in
 660*MINGW*)
 661        # Windows has its own (incompatible) sort and find
 662        sort () {
 663                /usr/bin/sort "$@"
 664        }
 665        find () {
 666                /usr/bin/find "$@"
 667        }
 668        sum () {
 669                md5sum "$@"
 670        }
 671        # git sees Windows-style pwd
 672        pwd () {
 673                builtin pwd -W
 674        }
 675        # no POSIX permissions
 676        # backslashes in pathspec are converted to '/'
 677        # exec does not inherit the PID
 678        test_set_prereq MINGW
 679        test_set_prereq NOT_CYGWIN
 680        test_set_prereq SED_STRIPS_CR
 681        ;;
 682*CYGWIN*)
 683        test_set_prereq POSIXPERM
 684        test_set_prereq EXECKEEPSPID
 685        test_set_prereq NOT_MINGW
 686        test_set_prereq CYGWIN
 687        test_set_prereq SED_STRIPS_CR
 688        ;;
 689*)
 690        test_set_prereq POSIXPERM
 691        test_set_prereq BSLASHPSPEC
 692        test_set_prereq EXECKEEPSPID
 693        test_set_prereq NOT_MINGW
 694        test_set_prereq NOT_CYGWIN
 695        ;;
 696esac
 697
 698( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
 699test -z "$NO_PERL" && test_set_prereq PERL
 700test -z "$NO_PYTHON" && test_set_prereq PYTHON
 701test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 702test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 703
 704# Can we rely on git's output in the C locale?
 705if test -n "$GETTEXT_POISON"
 706then
 707        GIT_GETTEXT_POISON=YesPlease
 708        export GIT_GETTEXT_POISON
 709        test_set_prereq GETTEXT_POISON
 710else
 711        test_set_prereq C_LOCALE_OUTPUT
 712fi
 713
 714# Use this instead of test_cmp to compare files that contain expected and
 715# actual output from git commands that can be translated.  When running
 716# under GETTEXT_POISON this pretends that the command produced expected
 717# results.
 718test_i18ncmp () {
 719        test -n "$GETTEXT_POISON" || test_cmp "$@"
 720}
 721
 722# Use this instead of "grep expected-string actual" to see if the
 723# output from a git command that can be translated either contains an
 724# expected string, or does not contain an unwanted one.  When running
 725# under GETTEXT_POISON this pretends that the command produced expected
 726# results.
 727test_i18ngrep () {
 728        if test -n "$GETTEXT_POISON"
 729        then
 730            : # pretend success
 731        elif test "x!" = "x$1"
 732        then
 733                shift
 734                ! grep "$@"
 735        else
 736                grep "$@"
 737        fi
 738}
 739
 740test_lazy_prereq PIPE '
 741        # test whether the filesystem supports FIFOs
 742        rm -f testfifo && mkfifo testfifo
 743'
 744
 745test_lazy_prereq SYMLINKS '
 746        # test whether the filesystem supports symbolic links
 747        ln -s x y && test -h y
 748'
 749
 750test_lazy_prereq CASE_INSENSITIVE_FS '
 751        echo good >CamelCase &&
 752        echo bad >camelcase &&
 753        test "$(cat CamelCase)" != good
 754'
 755
 756test_lazy_prereq UTF8_NFD_TO_NFC '
 757        # check whether FS converts nfd unicode to nfc
 758        auml=$(printf "\303\244")
 759        aumlcdiar=$(printf "\141\314\210")
 760        >"$auml" &&
 761        case "$(echo *)" in
 762        "$aumlcdiar")
 763                true ;;
 764        *)
 765                false ;;
 766        esac
 767'
 768
 769test_lazy_prereq AUTOIDENT '
 770        sane_unset GIT_AUTHOR_NAME &&
 771        sane_unset GIT_AUTHOR_EMAIL &&
 772        git var GIT_AUTHOR_IDENT
 773'
 774
 775# When the tests are run as root, permission tests will report that
 776# things are writable when they shouldn't be.
 777test -w / || test_set_prereq SANITY
 778
 779GIT_UNZIP=${GIT_UNZIP:-unzip}
 780test_lazy_prereq UNZIP '
 781        "$GIT_UNZIP" -v
 782        test $? -ne 127
 783'